/*####################################################################
 FILE: pca9635.ino
 VERSION: 1.0
 PURPOSE: I2C Circular LED Bar test sketch

 Description:
 * Communicates with the PCA9635 via the I2C bus.
 * A simple light animation is realized on the display.

 Connections:
 * BOARD -> ARDUINO
 * GND   -> GND
 * OE    -> 2
 * SDA   -> A4
 * SCL   -> A5
 * +5V   -> 5V

 HISTORY:
 Mirko Prosseda - Original version (23/10/2013)
#######################################################################*/


#include <pca9635.h>
#include <Wire.h>   // library used with I2C protocol

pca9635 PCA9635;

// try these different visual effects (uncomment only one row)
uint8_t l[16] = {255, 224, 192, 160, 128, 96, 64, 32, 0, 0, 0, 0, 0, 0, 0, 0};
//uint8_t l[16] = {255, 192, 128, 64, 0, 0, 0, 0, 255, 192, 128, 64, 0, 0, 0, 0};
//uint8_t l[16] = {255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
//uint8_t l[16] = {255, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, 0, 0, 0};
//uint8_t l[16] = {255, 0, 0, 0, 255, 0, 0, 0, 255, 0, 0, 0, 255, 0, 0, 0};
//uint8_t l[16] = {0, 0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255};
//uint8_t l[16] = {0, 0, 255, 255, 255, 255, 255, 255, 0, 0, 255, 255, 255, 255, 255, 255};
uint8_t i;


void setup()
{
    pinMode(OEpin, OUTPUT);
    digitalWrite(OEpin, LOW);
    Wire.begin();

    PCA9635.initialize();
}


void loop()
{
    uint8_t temp = l[0];
    for(i = 0; i < 15; i++)
        l[i] = l[i + 1];
    l[15] = temp;

    //  Update all LED brightness
    PCA9635.setBrightness(PWM0, l[0]);
    PCA9635.setBrightness(PWM1, l[1]);
    PCA9635.setBrightness(PWM2, l[2]);
    PCA9635.setBrightness(PWM3, l[3]);
    PCA9635.setBrightness(PWM4, l[4]);
    PCA9635.setBrightness(PWM5, l[5]);
    PCA9635.setBrightness(PWM6, l[6]);
    PCA9635.setBrightness(PWM7, l[7]);
    PCA9635.setBrightness(PWM8, l[8]);
    PCA9635.setBrightness(PWM9, l[9]);
    PCA9635.setBrightness(PWM10, l[10]);
    PCA9635.setBrightness(PWM11, l[11]);
    PCA9635.setBrightness(PWM12, l[12]);
    PCA9635.setBrightness(PWM13, l[13]);
    PCA9635.setBrightness(PWM14, l[14]);
    PCA9635.setBrightness(PWM15, l[15]);
    delay(25);
}
